<?php
class NewsController extends Zend_Controller_Action
{
  public function indexAction()
  {
    // get Twitter search feed
    $q = 'philately';
    $this->view->q = $q;
    
    // get cache
    $fileCache = $this->getInvokeArg('bootstrap')
                      ->getResource('cachemanager')
                      ->getCache('news');
    
    // read Twitter results from cache if available                                        
    $id = 'twitter';
    if(!($this->view->tweets = $fileCache->load($id))) {    
      $twitter = new Zend_Service_Twitter_Search();
      $this->view->tweets = $twitter->search($q, 
        array('lang' => 'en', 'rpp' => 8, 'show_user' => true));
      $fileCache->save($this->view->tweets, $id);        
    }  
      
    // cache feeds
    Zend_Feed_Reader::setCache($fileCache);
    
    // get Google News Atom feed
    $this->view->feeds = array();      
    $gnewsFeed = "http://news.google.com/news?hl=en&q=$q&output=atom";
    $this->view->feeds[0] = Zend_Feed_Reader::import($gnewsFeed);      
    
    // get BPMA RSS feed
    $bpmaFeed = "http://www.postalheritage.org.uk/news/RSS";
    $this->view->feeds[1] = Zend_Feed_Reader::import($bpmaFeed);      
  }
}
